enquete/accounts/urls.py
from django.urls import path
from . import views

urlpatterns = [

    path('register/', views.SignUp.as_view(), name="signup"),

]

enquete/clinica/urls.py
from django.urls import path, include
from . import views

app_name = 'clinica'
urlpatterns = [
    path('', views.index, name = 'index'),
    path('ficha/<int:id>', views.ficha, name="ficha"),
    path('listarFichas/', views.listarFichas, name="listarFichas"),
    path('criarFicha/', views.criarFicha, name="criarFicha"),
    path('registro/<int:id>', views.registro, name="registro"),
    path('novoregistro/<int:id>', views.novoregistro, name="novoregistro"),
    path('cadastrarRegistro/<int:id>', views.cadastrarRegistro, name="cadastrarRegistro"),
    path('accounts/', include('django.contrib.auth.urls')),

]

enquete/enquete/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls')),
    path('clinica/', include('clinica.urls')),
    path('accounts/', include('accounts.urls')),
    path('accounts/', include('django.contrib.auth.urls')),

]

enquete/main/urls.py
from django.urls import path
from . import views

app_name = 'main'
urlpatterns = [
    path('', views.home, name = 'home'),
    path('enquete',
        views.IndexView.as_view(), name = 'index'
    ),
    path('enquete/<int:pk>',
        views.DetalhesView.as_view(), name = 'detalhes'
    ),
    path('enquete/<int:pk>/resultado',
        views.ResultadoView.as_view(), name = 'resultado'
    ),
    path('enquete/<int:id_enquete>/votacao',
        views.votacao, name = 'votacao'
    ),
    path('enquete/<int:pk>/detalhecomentario/<int:id.comentario>',
        views.DetalheComentarioView.as_view(), name = 'detalhecomentario'
    ),
]

enquete/accounts/models.py
from django.db import models

# Create your models here.

enquete/clinica/models.py
from django.db import models


class Ficha(models.Model):
	nome = models.CharField(max_length=80)
	raca = models.CharField(max_length=80)
	idade = models.IntegerField()
	contato_dono = models.CharField(max_length=80)
	situacao = models.TextField()
	data_cadastro = models.DateTimeField(auto_now_add=True)

	def __str__(self):
		return self.nome

class Registro(models.Model):
	titulo = models.CharField(max_length=80,default='titulo')
	diagnostico = models.TextField()

	data_registro = models.DateTimeField(auto_now_add=True)


	ficha = models.ForeignKey(Ficha, on_delete = models.CASCADE)

	def __str__(self):
		return self.titulo

enquete/main/models.py
from django.db import models
from django.utils import timezone
import datetime

class Pergunta(models.Model):
    texto = models.CharField(max_length = 200)
    data_publicacao = models.DateTimeField('Data de Publicação')

    def __str__(self):
        return self.texto
    def publicada_recentemente(self):
        agora = timezone.now()
        return agora-datetime.timedelta(days=1) <= self.data_publicacao <= agora

class Opcao(models.Model):
    texto = models.CharField(max_length = 200)
    votos = models.IntegerField(default = 0)
    pergunta = models.ForeignKey(Pergunta, on_delete=models.CASCADE)
    def __str__(self):
        return self.texto

class Comentario(models.Model):
    nome_autor = models.CharField(max_length = 200)
    texto = models.CharField(max_length = 200)
    data_insercao = models.DateTimeField('Data de Publicação')
    Pergunta = models.ForeignKey(Pergunta, on_delete=models.CASCADE)
    def __str__(self):
        return self.texto

enquete/clinica/forms.py
from django import forms

from .models import Registro, Ficha

class RegistroForm(forms.ModelForm):

	class Meta:
		model = Registro
		fields = ('titulo', 'diagnostico')

class FichaForm(forms.ModelForm):

	class Meta:
		model = Ficha
		fields = ['nome', 'raca', 'idade', 'contato_dono', 'situacao']

enquete/accounts/views.py
from django.contrib.auth.forms import UserCreationForm
from django.urls import reverse_lazy
from django.views import generic

class SignUp(generic.CreateView):
	form_class = UserCreationForm
	success_url = reverse_lazy('login')
	template_name = 'registration/register.html'

enquete/clinica/views.py
from django.shortcuts import render, get_object_or_404, redirect
from django.core.paginator import Paginator
from django.contrib.auth.decorators import login_required
from .models import Registro, Ficha
from .forms import FichaForm

def index(request):
    return render(request, 'clinica/index.html', {})


def criarFicha(request):

	if request.method == 'POST':
		form = FichaForm(request.POST)

		if form.is_valid():
			ficha = form.save(commit=False)

			ficha.save()
			return redirect('/clinica/listarFichas')

	ficha = FichaForm()
	return render(request, 'clinica/criarFicha.html', {'ficha': ficha})




def listarFichas(request):

	fichas = Ficha.objects.all().order_by('-data_cadastro')

	return render(request, 'clinica/listarFichas.html', {'fichas': fichas})


@login_required
def ficha(request, id):

	ficha = get_object_or_404(Ficha, pk=id)

	search = request.GET.get('search')

	if search:

		registros = Registro.objects.filter(titulo__icontains=search)

	else:


		registros = Registro.objects.filter(ficha= id).order_by('-data_registro')

		paginator = Paginator(registros, 3)

		page = request.GET.get('page')

		registros = paginator.get_page(page)

	return render(request, 'clinica/ficha.html', {'registros': registros, 'ficha':ficha, 'registro':registro})


@login_required
def registro(request, id):
	registro = get_object_or_404(Registro, pk=id)
	return render(request, 'clinica/registro.html', {'registro': registro})



@login_required
def novoregistro(request, id):
	ficha = get_object_or_404(Ficha, pk=id)
	titulo = request.POST['titulo']
	diagnostico = request.POST['diagnostico']


	registro = Registro.objects.create(ficha=ficha, titulo=titulo, diagnostico=diagnostico)
	registro.save()
	return redirect('clinica:ficha', id)


@login_required
def cadastrarRegistro(request, id):
	ficha = get_object_or_404(Ficha, pk=id)
	return render(request, 'clinica/novoregistro.html', {'ficha':ficha})

enquete/main/views.py
from django.shortcuts import render, get_object_or_404
from django.http import HttpResponseRedirect
from django.urls import reverse
from django.views import generic
from django.utils import timezone
from .models import Pergunta, Opcao, Comentario

def home(request):
    return render(request, 'main/home.html', {})

class IndexView(generic.ListView):
    def get_queryset(self):
        return Pergunta.objects.filter(data_publicacao__lte=timezone.now()
        ).order_by('-data_publicacao')[:5]

class DetalhesView(generic.DetailView):
    model = Comentario
    model = Pergunta
    def get_queryset(self):
        return Pergunta.objects.filter(data_publicacao__lte=timezone.now())
        return Comentario.objects.filter(data_publicacao__lte=timezone.now())




class ResultadoView(generic.DetailView):
    model = Pergunta
    template_name = 'main/resultado.html'

def votacao(request, id_enquete):
    pergunta = get_object_or_404(Pergunta, pk=id_enquete)
    try:
        opcao_selecionada = pergunta.opcao_set.get(pk=request.POST['opcao'])
    except (KeyError, Opcao.DoesNotExist):
        return render(request, 'main/detalhes.html', {
            'pergunta': pergunta,
            'error_message': "Selecione uma opção VÁLIDA!"
        })
    else:
        opcao_selecionada.votos += 1
        opcao_selecionada.save()
        return HttpResponseRedirect(
            reverse('main:resultado', args=(pergunta.id,))
        )

class DetalheComentarioView(generic.DetailView):
    model = Pergunta
    model = Comentario
    template_name = 'main/detalhecomentario.html'

enquete/clinica/templates/base.html
{% load static %}
<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<meta http-equiv="X-UA-Compatible" content="ie=edge">
	<title>{% block title %}{% endblock %}</title>
	<link href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
	<script src="https://kit.fontawesome.com/d465495bba.js" crossorigin="anonymous"></script>
	<link rel="stylesheet" href="{% static 'css/styles.css' %}">
    <style>
        .navbar {
	border-bottom: 1px solid #333;
	margin-bottom: 20px;
	background-color: black;
	 height: 80px;
}

.navbar-nav{
	margin: auto;

}

    </style>
</head>
<body>








	<div class="container-fluid" style="padding:0">
		<nav class="navbar navbar-expand-lg navbar-light" >
  <a class="navbar-brand" style="padding-left: 200px; color:white;" href="/clinica/listarFichas">Fichas</a>
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  	<div class="collapse navbar-collapse" id="navbarSupportedContent">
    <ul class="navbar-nav mr-auto">
    	{% if user.is_authenticated %}

     	{% else %}
     	      <li class="nav-item">
        <a class="nav-link" style="color:white; padding-left: 500px;" href="/accounts/login">Entrar</a>
      </li>

     	{% endif %}


      	{% if user.is_authenticated %}

      	<li class="nav-item active">
        <a class="nav-link" style="color:white; padding-left: 500px;" href="/accounts/logout">Sair</a>
      </li>
      {% endif %}

    </ul>

  	</div>
</nav>
	{% block content %}

	{% endblock %}


	</div>


	<script src="https://code.jquery.com/jquery-3.4.1.slim.min.js" integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>
	<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>
	<script src="{% static 'js/scripts.js' %}"></script>
</body>
</html>

enquete/clinica/templates/clinica/criarFicha.html
{% extends 'base.html' %}




{% block title %}Adicione um Registro{% endblock %}

{% block content %}
<div class="offset-1 col-10 list-div">
	<h1>Adicione uma nova ficha:</h1>
	<form method="POST" action="{% url 'clinica:criarFicha' %}">
		{% csrf_token %}
		<div class="form-group">
    	Nome:
    	<input class="form-control"  name="nome">
    	</div>
    	<div class="form-group">
    	Animal:
    	<input class="form-control"  name="raca">
    	</div>
    	<div class="form-group">
    	Idade:
    	<input class="form-control"  name="idade">
    	</div>
    	<div class="form-group">
    	Contato do dono
    	<input class="form-control"  name="contato_dono">
    	</div>
    	<div class="form-group">
    	Situação
    	<input class="form-control"  name="situacao">
    	</div>
		<a href="/clinica/criarFicha"><input type="submit" class="btn btn-success" value="Criar Ficha"> </a>

	</form>
</div>
{% endblock %}

enquete/clinica/templates/clinica/ficha.html
{% extends 'base.html' %}
{% load crispy_forms_tags %}


{% block title %}Ficha de paciente{% endblock %}

{% block content %}
<div class="offset-1 col-10 list-div">
    <h2>Ficha do paciente "{{ ficha.nome }}"</h2>
	<div class="card" style="padding:50px; margin: 50px;">

	<div class="card-body">
	<h5>Nome: '{{ ficha.nome }}'</h5>
	</div>
	<div class="card-body">
	<h5>Animal: '{{ ficha.raca }}'</h5>
	</div>
	<div class="card-body">
	<h5>Idade:'{{ ficha.idade }}'</h5>
	</div>
	<div class="card-body">
	<h5>Contato do dono: '{{ ficha.contato_dono }}'</h5>
	</div>
	<div class="card-body">
	<h5>Situação do paciente: '{{ ficha.situacao }}'</h5>
	</div>
	</div>



	<h3>Registros</h3>

	<a id="add-link" href="{% url 'clinica:cadastrarRegistro' ficha.id %}">

	<div class="col-2 add-div">
		<i class="fas fa-plus"></i> Adicionar Registro
	</div>
	</a>


	<div class="col-9 search-div">
		<form method="GET" id="search-form">
		<input class="form-control" type="text" id="search" name="search" placeholder="Digite o nome do registro">
		<i class="fas fa-search" id="search-btn"></i>
		</form>
	</div>


	{% if messages %}
		<ul class="messages">
			{% for message in messages %}
			<li {% if message.tags %} class="alert alert-{{message.tags}}"{% endif %}>{{ message }}</li>
			{% endfor %}

		</ul>
	{% endif %}
	<ul class="task-list">
		{% for registro in registros %}

		<li class="task-item">
			<span><a href="{% url 'clinica:registro' registro.id %}">{{registro.titulo}}</a></span>

		</li>
		{% endfor %}
	</ul>
	<div class="pagination">
		<span class="step-links">
			{% if registros.has_previous %}
				<a href="?page={{ registros.previous_page_number }}"><i class="fas fa-arrow-left"> </i></a>
			{% endif %}

			{% if registros.paginator.num_pages %}
			<span class="current">
				{{ registros.number }} de {{ registros.paginator.num_pages }}
			</span>
			{% endif %}

			{% if registros.has_next %}
				<a href="?page={{ registros.next_page_number }}"><i class="fas fa-arrow-right"> </i></a>
			{% endif %}
		</span>

	</div>
</div>
{% endblock %}

enquete/clinica/templates/clinica/index.html
<html>
    <head>
            <title>App Clínica</title>
    </head>
    <body>
        <h1>Aplicação Clínica</h1>


    </body>
</html>

enquete/clinica/templates/clinica/listarFichas.html
{% extends 'base.html' %}


{% block title %}Fichas{% endblock %}

{% block content %}
	<div class="container">


        <p><i>Sessão de fichas onde o atendente cadastra fichas de animais, o mesmo só pode cadastrar e ver a lista de fichas, o resto apenas o médico pode acessar por meio de login.</i></p>
	    <h1>Clínica Veterinária</h1>
	<div class="card" style="padding: 20px; margin-top: 30px;">

	<a id="add-link" href="/clinica/criarFicha">
	<div class="add-div">
		<i class="fas fa-plus"></i>Adicionar uma ficha
	</div>
	</a>
	<br>

	<h4>Fichas de pacientes:</h4>
{% for ficha in fichas %}

			<div class="task-items" style="padding: 20px;">

			<span><a style="color: gray; font-size: 20px;" href="/clinica/ficha/{{ficha.id}}">{{ficha.nome}}</a></span>
			</div>

{% endfor %}
</div>
</div>
{% endblock %}

enquete/clinica/templates/clinica/novoregistro.html
{% extends 'base.html' %}
{% load crispy_forms_tags %}


{% block title %}Adicione um Registro{% endblock %}

{% block content %}
<div class="offset-1 col-10 list-div">
	<h1>Adicione um novo registro:</h1>
	<form method="POST" action="{% url 'clinica:novoregistro' ficha.id %}">
		{% csrf_token %}
		<div class="form-group">
    	Título:
    	<input class="form-control"  name="titulo">
    	</div>
    	<div class="form-group">
    	Diagnóstico:
    	<input class="form-control"  name="diagnostico">
    	</div>

		<input type="submit" class="btn btn-success" value="Criar Ficha">
	</form>
</div>
{% endblock %}

enquete/clinica/templates/clinica/registro.html
{% extends 'base.html' %}
{% load crispy_forms_tags %}



{% block title %}Registro{% endblock %}

{% block content %}
<div class="container">
	<h3>{{registro.titulo}}</h3>
</div>
<div class="offset-1 col-10 list-div">
	<div class="card" style="padding:50px; margin: 50px;">
	<p>{{registro.diagnostico}}</p>
    </div>
</div>
{% endblock %}

enquete/main/templates/main/detalhecomentario.html
<html>
    <head>
        <title>App Enquete</title>
    </head>
    <boby>


            <h1>Comentário:</h1>:<br/>
            <span style="font-size: 22px;">{{ comentario.texto }}</span>
            <br>
            <hr>
            <h4><u>Data de Publicação</u>: {{ comentario.data_insercao }}</br>
            <br>
            <a href="{% url 'main:index' %}"><<< Retorne a página principal</a></h4>



    </boby>
</html>

enquete/main/templates/main/home.html
<html>
    <head>
            <title>Aplicações DSWeb</title>
    </head>
    <body>
        <h1>Aplicações de DSWeb</h1>
        <h3>Selecione a aplicação desejada:</h3>
        <ul>
            <li><a href="{% url 'main:index' %}">Aplicação Enquete - Módulo 1</a></li>
            <li><a href="{% url 'clinica:listarFichas' %}">Aplicação Clínica Veterinária - Módulo 2</a></li>
        </ul>
        <hr>

    </body>
</html>

enquete/main/templates/main/index.html
<html>
    <head>
            <title>Aplicações DSWeb</title>
    </head>
    <body>
        <h1>Aplicações de DSWeb</h1>
        <h3>Selecione a aplicação desejada:</h3>
        <ul>
            <li><a href="{% url 'main:enquete' %}">Aplicação Enquete - Módulo 1</a></li>
            <li><a href="{% url 'clinica:index' %}">Aplicação Clínica Veterinária - Módulo 2</a></li>
        </ul>
        <hr>

    </body>
</html>

enquete/main/templates/main/pergunta_detail.html
<html>
    <head>
        <title>App Enquete</title>
    </head>
    <boby>
        <h2>Detalhes da Enquete {{ pergunta.id }}</h2>
        <u>Pergunta</u>: {{ pergunta.texto }}<br/>
        <u>Data de Publicação</u>: {{ pergunta.data_publicacao }}
        {% if error_message %}
            <hr/>
            <strong>{{ error_message }}</strong>
            <hr/>
        {% endif %}
        <form action="{% url 'main:votacao' pergunta.id %}" method="post">
            {% csrf_token %}
            <ul>
                {% for opcao in pergunta.opcao_set.all %}
                    <li><input type="radio" name="opcao"
                        id="opcao{{ forloop.counter }}" value="{{ opcao.id }}">
                        <label for="opcao{{ forloop.counter }}">
                            {{ opcao.texto }}
                        </label>
                    </li>
                {% endfor %}





            </ul>
            <input type="submit" value="Registre o seu Voto">
        </form>
        <hr>
        <a href="{% url 'main:index' %}">Retorne a página principal</a>
        <br>

        <h2>Comentários sobre esta enquete:</h2>

        <br>
        {% for comentario in pergunta.comentario_set.all %}
        <h4><a href="{% url 'main:detalhecomentario' comentario.id %}">{{ comentario.texto }}</a></br></h4>
        <br>
        {% endfor %}
    </boby>
</html>

enquete/main/templates/main/pergunta_list.html
<html>
    <head>
        <title>App Enquete</title>
    </head>
    <body>
        {% if pergunta_list %}
            <h2>Lista das Últimas Enquetes</h2>
            <ul>
                {% for pergunta in pergunta_list %}
                    <li><a href="{% url 'main:detalhes' pergunta.id %}">
                        {{ pergunta.texto }}
                    </a> (<a href="{% url 'main:resultado' pergunta.id %}">ver parcial</a>)</li>
                {% endfor %}
            </ul>
        {% else %}
            <h3>Não há enquetes cadastradas até o momento!</h3>
        {% endif %}
    </body>
</html>

enquete/main/templates/main/resultado.html
<html>
    <head>
        <title>App Enquete</title>
    </head>
    <body>
        <h2>Resultado Parcial da Enquete {{ pergunta.id }}</h2>
        <u>Pergunta</u>: {{ pergunta.texto }}<br/>
        <u>Data de Publicação</u>: {{ pergunta.data_publicacao }}
        <ul>
            {% for opcao in pergunta.opcao_set.all %}
                <li>{{ opcao.texto }} = {{ opcao.votos }}
                voto{{ opcao.votos | pluralize }}</li>
            {% endfor %}
        </ul>
        <hr/>
        <a href="{% url 'main:detalhes' pergunta.id %}">Deseja votar novamente?</a> |
        <a href="{% url 'main:index' %}">Retornar à página principal</a>
    </body>
</html>